 'Shareware Starter Kit --BuyNowForm
'Summary:  This is the default form provided for the buy now experience.
'Author: Brian Trautman briant@personifydesign.com
'Date Created: 4/11/2004
'Date Last Modified: 4/13/2005
'
'ToDo: Error processing original source shown below
'
'#region using directives
'-^--- expression expected
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Threading
Imports Client.SSK.SSKClient.ClientStorage
Imports Client.SSK.SSKClient.UIHelper
Imports System.Drawing.Drawing2D

'
'ToDo: Error processing original source shown below
'using System.Drawing.Drawing2D;
'#endregion
'-^--- expression expected

Namespace SSK.SSKClient.SSKForms
   
   
   
   '/ <summary>
   '/ The buy now form provides users a way to purchase and activate the application.  The default
   '/ payment integration is with PayPal.
   '/ </summary>
   '/ <exception cref="DataStoreAppConfigException">
   '/ If the datastore has not been initialized before the form was created this exception will be thrown.
   '/ </exception>
   
   Public Class BuyNowForm
      Inherits System.Windows.Forms.Form
      #Region "Private variables"
      Private components As IContainer
      Private m_buynowhelper As BuyNowHelper
      Private m_eFormState As Formstate
      Private topPanel As Panel
      Private middlePanel As Panel
      Private bottomPanel As Panel
      Private enterProductKeyRadio As RadioButton
      Private purchaseProductRadio As RadioButton
      Private WithEvents back As Button
      Private cancel As Button
      Private errorProvider1 As ErrorProvider
      Private WithEvents [next] As Button
      Private purchaseProductKey As Boolean = False
      Private enterProductKey As Boolean = False
      Private grfx As Graphics
      Private dataStore As DataStore
      
      
      Private Enum Formstate
         Initial
         Buynowprocessing
         Buynowprocessingcomplete
         BuyNowError
         ActivateNow
         ActivateNowProcessing
         ActivateNowProcessingComplete
         ActivateNowError
         Registrationprocessing
         Registrationprocessingcomplete
         SelectLicensing
         [Error]
      End Enum 'Formstate
      #End Region
      
      #Region "Windows Form Designer generated code"
      
      '/ <summary>
      '/ Required method for Designer support - do not modify
      '/ the contents of this method with the code editor.
      '/ </summary>
      Private Sub InitializeComponent()
         Me.components = New System.ComponentModel.Container()
         Me.topPanel = New System.Windows.Forms.Panel()
         Me.middlePanel = New System.Windows.Forms.Panel()
         Me.enterProductKeyRadio = New System.Windows.Forms.RadioButton()
         Me.purchaseProductRadio = New System.Windows.Forms.RadioButton()
         Me.bottomPanel = New System.Windows.Forms.Panel()
         Me.back = New System.Windows.Forms.Button()
         Me.cancel = New System.Windows.Forms.Button()
         Me.next = New System.Windows.Forms.Button()
         Me.errorProvider1 = New System.Windows.Forms.ErrorProvider(Me.components)
         Me.middlePanel.SuspendLayout()
         Me.bottomPanel.SuspendLayout()
         CType(Me.errorProvider1, System.ComponentModel.ISupportInitialize).BeginInit()
         Me.SuspendLayout()
         ' 
         ' topPanel
         ' 
         Me.topPanel.BackColor = System.Drawing.Color.Transparent
         Me.topPanel.Dock = System.Windows.Forms.DockStyle.Top
         Me.topPanel.Location = New System.Drawing.Point(0, 0)
         Me.topPanel.Name = "topPanel"
         Me.topPanel.Size = New System.Drawing.Size(569, 51)
         Me.topPanel.TabIndex = 0
         ' 
         ' middlePanel
         ' 
         Me.middlePanel.BackColor = System.Drawing.Color.Transparent
         Me.middlePanel.Controls.Add(Me.enterProductKeyRadio)
         Me.middlePanel.Controls.Add(Me.purchaseProductRadio)
         Me.middlePanel.Dock = System.Windows.Forms.DockStyle.Fill
         Me.middlePanel.Location = New System.Drawing.Point(0, 51)
         Me.middlePanel.Name = "middlePanel"
         Me.middlePanel.Size = New System.Drawing.Size(569, 363)
         Me.middlePanel.TabIndex = 1
         ' 
         ' enterProductKeyRadio
         ' 
         Me.enterProductKeyRadio.AutoSize = True
         Me.enterProductKeyRadio.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.enterProductKeyRadio.Location = New System.Drawing.Point(170, 150)
         Me.enterProductKeyRadio.Name = "enterProductKeyRadio"
         Me.enterProductKeyRadio.Size = New System.Drawing.Size(169, 22)
         Me.enterProductKeyRadio.TabIndex = 6
         Me.enterProductKeyRadio.TabStop = False
         Me.enterProductKeyRadio.Text = "Enter a product key"
         ' 
         ' purchaseProductRadio
         ' 
         Me.purchaseProductRadio.AutoSize = True
         Me.purchaseProductRadio.Checked = True
         Me.purchaseProductRadio.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.purchaseProductRadio.Location = New System.Drawing.Point(170, 105)
         Me.purchaseProductRadio.Name = "purchaseProductRadio"
         Me.purchaseProductRadio.Size = New System.Drawing.Size(200, 22)
         Me.purchaseProductRadio.TabIndex = 5
         Me.purchaseProductRadio.Text = "Purchase a product key"
         ' 
         ' bottomPanel
         ' 
         Me.bottomPanel.BackColor = System.Drawing.Color.Transparent
         Me.bottomPanel.Controls.Add(Me.back)
         Me.bottomPanel.Controls.Add(Me.cancel)
         Me.bottomPanel.Controls.Add(Me.next)
         Me.bottomPanel.Dock = System.Windows.Forms.DockStyle.Bottom
         Me.bottomPanel.Location = New System.Drawing.Point(0, 365)
         Me.bottomPanel.Name = "bottomPanel"
         Me.bottomPanel.Size = New System.Drawing.Size(569, 49)
         Me.bottomPanel.TabIndex = 2
         ' 
         ' back
         ' 
         Me.back.Enabled = False
         Me.back.Location = New System.Drawing.Point(392, 11)
         Me.back.Name = "back"
         Me.back.Size = New System.Drawing.Size(75, 23)
         Me.back.TabIndex = 3
         Me.back.Text = "< Back"
         ' 
         ' cancel
         ' 
         Me.cancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
         Me.cancel.Location = New System.Drawing.Point(280, 11)
         Me.cancel.Name = "cancel"
         Me.cancel.Size = New System.Drawing.Size(75, 23)
         Me.cancel.TabIndex = 2
         Me.cancel.Text = "Cancel"
         ' 
         ' next
         ' 
         Me.next.Location = New System.Drawing.Point(479, 11)
         Me.next.Name = "next"
         Me.next.Size = New System.Drawing.Size(75, 23)
         Me.next.TabIndex = 1
         Me.next.Text = "Next >"
         ' 
         ' errorProvider1
         ' 
         Me.errorProvider1.ContainerControl = Me
         ' 
         ' BuyNowForm
         ' 
         Me.AcceptButton = Me.next
         Me.BackColor = System.Drawing.Color.Silver
            Me.BackgroundImage = My.Resources.Resource1.activation_options
         Me.CancelButton = Me.cancel
         Me.ClientSize = New System.Drawing.Size(569, 414)
         Me.Controls.Add(bottomPanel)
         Me.Controls.Add(middlePanel)
         Me.Controls.Add(topPanel)
         Me.Name = "BuyNowForm"
         Me.ShowInTaskbar = False
         Me.Text = "BuyNowForm"
         Me.middlePanel.ResumeLayout(False)
         Me.middlePanel.PerformLayout()
         Me.bottomPanel.ResumeLayout(False)
         CType(Me.errorProvider1, System.ComponentModel.ISupportInitialize).EndInit()
         Me.ResumeLayout(False)
      End Sub 'InitializeComponent
       
      
      
      '/ <summary>
      '/ Clean up any resources being used.
      '/ </summary>
      Protected Overrides Sub Dispose(disposing As Boolean)
         If disposing Then
            If Not (components Is Nothing) Then
               components.Dispose()
            End If
         End If
         MyBase.Dispose(disposing)
      End Sub 'Dispose
      #End Region
      
      #Region "Constructors"
      
      '/ <summary>
      '/ The constructor for the buy now form.
      '/ </summary>
      '/ <exception cref="DataStoreAppConfigException">
      '/ If the datastore has not been initialized before the form was created this exception will be thrown.
      '/ </exception>
      Public Sub New()
         '
         ' Required for Windows Form Designer support
         '
         InitializeComponent()
         
         dataStore = New DataStore(Me)
         
         '/Initialize the buy now helper class and pass in a reference to the current form.
         m_buynowhelper = New BuyNowHelper(Me)
         
         '/Set up the required event handlers for processing failed and processing complete.
            AddHandler m_buynowhelper.ProcessingComplete, AddressOf Me.ProccessingComplete '
            AddHandler m_buynowhelper.Processingfailed, AddressOf Me.ProccessingFailed '

         '/Set up the event handler to capture the form closing event so clean up can be done.
         AddHandler Me.Closing, AddressOf BuyNowForm_Closing
         
         '/Create the variable to hold form state and set to initial
         m_eFormState = New Formstate()
         m_eFormState = Formstate.Initial
         
         
         If dataStore.PaymentSettings Is Nothing Then
            
            Dim message As String = "You Cannot use this form until a valid datastore has been received from the web service."
            MessageBox.Show(message)
            Me.Close()
                Throw New Client.DataStoreAppConfigException(message)
         End If 
      End Sub 'New 
      #End Region
      
      #Region "Form Event Handlers"
      
      
      
      '/ <summary>
      '/ Called by BuyNowHelper on processing completion.
      '/ The event triggers the form to go into the completion stage and show the completion message.
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub ProccessingComplete(sender As Object, e As ProcessingCompletedEvent)
         ' Map the delegate to the instance method:
            Dim d As New MarshallThisFuncString(AddressOf SetFormBuyNowProcessingComplete)
         
         'invoke on the original form reference
         e.FormReference.Invoke(d, New Object() {e.Message})
      End Sub 'ProccessingComplete
      
      
      '/ <summary>
      '/ Called by BuyNowHelper on processing failed.
      '/ When processing fails pass the message received in the eventargs to be displayed for the user.
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub ProccessingFailed(sender As Object, e As ProcessingFailedEvent)
         
         System.Diagnostics.Debug.WriteLine(("Processing Failed Buy Now Form: " + e.Message))
         
         ' Map the delegate to the instance method:
            Dim d As New MarshallThisFuncFailureInfo(AddressOf SetFormBuyNowProcessingFailed)
         
         'invoke on the original form reference
         e.FormReference.Invoke(d, New Object() {e.FailureInformation})
      End Sub 'ProccessingFailed
      
      
      
      
      
      '/ <summary>
      '/ The event handler for the cancel button closes the form.
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub cancel_Click(sender As Object, e As System.EventArgs)
         Me.Close()
      End Sub 'cancel_Click
      
      
      '/ <summary>
      '/ The event handler for form closing.  This gives us a chance to cancel web service calls and do cleanup before the
      '/ form is disposed.
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub BuyNowForm_Closing(sender As Object, e As CancelEventArgs)
         m_buynowhelper.Cancelprocessing()
      End Sub 'BuyNowForm_Closing
      
      
      '/ <summary>
      '/ The event handler for the form next button.
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
        Private Sub next_Click(ByVal sender As Object, ByVal e As EventArgs) Handles [next].Click

            Dim validator As New FormValidator.ControlValidator(AddressOf FormValidator.Hastextvalidator)

            Select Case m_eFormState
                Case Formstate.Initial
                    If purchaseProductRadio.Checked Then
                        purchaseProductKey = True
                        enterProductKey = False
                        SetFormSelectLicensingLevel()
                    End If
                    If enterProductKeyRadio.Checked Then
                        purchaseProductKey = False
                        enterProductKey = True
                        SetFormActivateNow()
                    End If


                Case Formstate.SelectLicensing
                    '/The user is proceeding to buy a new product key.
                    If purchaseProductKey Then
                        SetFormBuyNowProcessing()
                    End If

                Case Formstate.ActivateNow
                    '/Validate the product key enter box to make sure it is not blank.                    
                    If FormValidator.Fieldisvalid(Me.errorProvider1, Me.middlePanel.Controls.Find("productKey", False)(0), "Please enter a valid Product Key.", validator) Then
                        SetFormActivateNowProcessing()
                    End If
                Case Formstate.ActivateNowError
                    '/Validate the product key enter box to make sure it is not blank.  
                    If FormValidator.Fieldisvalid(Me.errorProvider1, Me.middlePanel.Controls.Find("productKey", False)(0), "Please enter a valid Product Key.", validator) Then
                        SetFormActivateNowProcessing()
                    End If
                Case Formstate.ActivateNowProcessingComplete
                    DisplayRegistrationForm()
                Case Formstate.Buynowprocessingcomplete
                    DisplayRegistrationForm()
                Case Else
            End Select
        End Sub 'next_Click
      
      
      
      '/ <summary>
      '/ The event handler for the back button
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub back_Click(sender As Object, e As EventArgs) Handles back.Click
         Select Case m_eFormState
            Case Formstate.SelectLicensing
               SetFormInitial()
            Case Formstate.Buynowprocessing
               SetFormSelectLicensingLevel()
               m_buynowhelper.Cancelprocessing()
            Case Formstate.ActivateNow
               'SetFormSelectLicensingLevel();
               SetFormInitial()
            Case Formstate.ActivateNowError
               SetFormInitial()
            Case Else
               Me.Close()
         End Select
      End Sub 'back_Click
      
      
      '/ <summary>
      '/ Event handler for text changes in the product key entry box.  When the length of the product key
      '/ is greater than 0 the next button is enabled, otherwise it's disabled.
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Sub productKey_TextChanged(sender As Object, e As EventArgs)
         Dim productKey As System.Windows.Forms.TextBox
         productKey = CType(sender, TextBox)
         If productKey.Text.Length > 0 Then
            [next].Enabled = True
         Else
            [next].Enabled = False
         End If
      End Sub 'productKey_TextChanged
      
      #End Region
      
      #Region "Private helper functions"
      
      '/ <summary>
      '/ Initialize the state of the form
      '/ </summary>
      Private Sub SetFormInitial()
         HideMiddlePanelControls()
         purchaseProductRadio.Visible = True
         enterProductKeyRadio.Visible = True
         back.Enabled = False
         cancel.Enabled = True
         [next].Enabled = True
            Me.BackgroundImage = My.Resources.Resource1.activation_options
         m_eFormState = Formstate.Initial
         Me.Name = "Activation Options"
      End Sub 'SetFormInitial
      
      
      '/ <summary>
      '/ Set the form to display the available license levels for purchase and activation.
      '/ </summary>
      Private Sub SetFormSelectLicensingLevel()
         Dim verticalIndex As Integer = 0
         Dim firstLicenseLevel As Boolean = True
         
         'Make the existing conrols invisible
         HideMiddlePanelControls()
         
         'set the form name and the background image
         Me.Name = "Select a License Level"
            Me.BackgroundImage = My.Resources.Resource1.select_license
         
         
         
         Dim availableLicenseLevel As Client.SskWebService.LicenseLevelsPrice
         For Each availableLicenseLevel In  dataStore.AvailableLicenseLevels
            If Not availableLicenseLevel.IsTrialLicensekey Then
               Dim licenseSelection As New RadioButton()
               Dim licenseSelectionDescription As New TextBox()
               
               licenseSelection.Text = availableLicenseLevel.LicenseLevel + " (" + String.Format("{0:c}", availableLicenseLevel.LicenseLevelPrice) + ")"
               licenseSelection.Name = "LicenseSelection"
               licenseSelection.Tag = availableLicenseLevel
               licenseSelection.AutoSize = True
               
               licenseSelectionDescription.AutoSize = True
               licenseSelectionDescription.Name = "LicenseSelectionDescription"
               licenseSelectionDescription.Text = availableLicenseLevel.Description
               licenseSelectionDescription.Multiline = True
               licenseSelectionDescription.ReadOnly = True
               licenseSelectionDescription.BorderStyle = BorderStyle.None
               licenseSelectionDescription.BackColor = Color.White
               
               
               
               If firstLicenseLevel Then
                  licenseSelection.Checked = True
               End If
               
               licenseSelection.Size = New System.Drawing.Size(200, 22)
               licenseSelection.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CByte(0))
               licenseSelection.Location = New System.Drawing.Point(170, 105 + verticalIndex)
               Me.middlePanel.Controls.Add(licenseSelection)
               
               licenseSelectionDescription.Size = New System.Drawing.Size(350, 45)
               licenseSelectionDescription.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
               licenseSelectionDescription.Location = New System.Drawing.Point(170, 130 + verticalIndex)
               Me.middlePanel.Controls.Add(licenseSelectionDescription)
               
               verticalIndex += 70
               
               firstLicenseLevel = False
            End If 
         Next availableLicenseLevel
         
         
         Me.back.Enabled = True
         Me.next.Enabled = True
         
         m_eFormState = Formstate.SelectLicensing
      End Sub 'SetFormSelectLicensingLevel
       
      
      
      '/ <summary>
      '/ Set the  form for the Buy Now processing sequence.
      '/ </summary>
      Private Sub SetFormBuyNowProcessing()
         Dim selectedLicenseLevel As RadioButton
         Dim licenseLevel As Client.SskWebService.LicenseLevelsPrice
         
         Dim control As Control
         For Each control In  Me.middlePanel.Controls
            If control.Name = "LicenseSelection" Then
               selectedLicenseLevel = CType(control, RadioButton)
               
               If selectedLicenseLevel.Checked Then
                  licenseLevel = CType(selectedLicenseLevel.Tag, Client.SskWebService.LicenseLevelsPrice)
                  m_buynowhelper.RequestedLicenseLevel = licenseLevel.LicenseLevel
                  m_buynowhelper.RequestedLicenseLevelPrice = licenseLevel.LicenseLevelPrice.ToString()
               End If
            End If
         Next control
         
         'launch the Paypal window
            Dim paymentThreadStarter As New ThreadStart(AddressOf m_buynowhelper.Handlepayment)
         Dim paymentThread As New Thread(paymentThreadStarter)
         paymentThread.Start()
         
         
         'start the web service polling for a result of the Paypal transaction
            Dim handleProcessingThreadStarter As New ThreadStart(AddressOf m_buynowhelper.Handleprocessing)
         Dim handleProcessingThread As New Thread(handleProcessingThreadStarter)
         handleProcessingThread.Start()
         
         'Make the existing conrols invisible
         HideMiddlePanelControls()
         
         'Set the header status text and center the label
         'this.headerLabel.Text = "Purchase a Product Key";
         Me.Name = "Purchase a Product Key"
         'CenterLabel(headerLabel);
            Me.BackgroundImage = My.Resources.Resource1.purchase_key

         '/Add the control to display the graphical network connection animation
         Dim webAnimation = New PictureBox()
         webAnimation.Anchor = System.Windows.Forms.AnchorStyles.None
            webAnimation.Image = My.Resources.Resource1.globeGIFanime
         webAnimation.Location = New System.Drawing.Point(170, 60)
         webAnimation.Name = "webAnimationIcon"
         webAnimation.Size = New System.Drawing.Size(324, 72)
         webAnimation.TabIndex = 3
         webAnimation.TabStop = False
         Me.middlePanel.Controls.Add(webAnimation)
         
         '/Add the label to display status text to the user
         Dim processingLabel = New Label()
         processingLabel.Anchor = System.Windows.Forms.AnchorStyles.None
         processingLabel.Location = New System.Drawing.Point(170, 150)
         processingLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         processingLabel.Name = "processingLabel"
         processingLabel.AutoSize = True
         processingLabel.Text = "Waiting for payment confirmation..."
         processingLabel.Size = New System.Drawing.Size(150, 75)
         processingLabel.Visible = True
         Me.middlePanel.Controls.Add(processingLabel)
         CenterLabel(processingLabel)
         
         '/Set the state of the form buttons
         back.Enabled = True
         cancel.Enabled = True
         [next].Enabled = False
         
         '/Set the state of the form
         m_eFormState = Formstate.Buynowprocessing
      End Sub 'SetFormBuyNowProcessing
      
      
      '/ <summary>
      '/ Set the form for the Activate now processing sequence.
      '/ </summary>
      Private Sub SetFormActivateNowProcessing()
         
         
         Dim invoice As String = Nothing
         Dim productKey As TextBox
         
         HideMiddlePanelControls()
         
         'Set the label text and center
         'this.headerLabel.Text = "Enter a Product Key";
         Me.Name = "Enter a Product Key"
         'CenterLabel(headerLabel);
            Me.BackgroundImage = My.Resources.Resource1.enter_key
         
         '/Add the control to display the graphical network connection animation
         Dim webAnimation = New PictureBox()
         webAnimation.Anchor = System.Windows.Forms.AnchorStyles.None
            webAnimation.Image = My.Resources.Resource1.globeGIFanime
         webAnimation.Location = New System.Drawing.Point(170, 60)
         webAnimation.Name = "webAnimationIcon"
         webAnimation.Size = New System.Drawing.Size(324, 72)
         webAnimation.TabIndex = 3
         webAnimation.TabStop = False
         Me.middlePanel.Controls.Add(webAnimation)
         
         '/Add the label to display status text to the user
         Dim processingLabel = New Label()
         processingLabel.Anchor = System.Windows.Forms.AnchorStyles.None
         processingLabel.Location = New System.Drawing.Point(170, 150)
         processingLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         processingLabel.Name = "processingLabel"
         processingLabel.AutoSize = True
         processingLabel.Text = "Waiting for product key confirmation..."
         processingLabel.Size = New System.Drawing.Size(150, 75)
         processingLabel.Visible = True
         Me.middlePanel.Controls.Add(processingLabel)
         CenterLabel(processingLabel)
         
         '/Locate the product key text input in the middle panel and set the invoice private variable
         '/to be the text input
         Dim c As Control
         For Each c In  middlePanel.Controls
            If c.Name = "productKey" Then
               productKey = CType(c, TextBox)
               
               invoice = productKey.Text
            End If
         Next c
         
         'buynowhelper.RequestedLicenseLevel = "Premium";
         '/Pass the invoice string to the buyNowHelper for processing with the web service.
         m_buynowhelper.Invoice = invoice
         
            Dim paymentThreadStarter As New ThreadStart(AddressOf m_buynowhelper.HandleProcessingInvoice)
         Dim paymentThread As New Thread(paymentThreadStarter)
         paymentThread.Start()
         
         
         '/Set the form buttons
         [next].Enabled = False
         back.Enabled = False
         cancel.Enabled = True
         
         '/Set the state of the form
         m_eFormState = Formstate.ActivateNowProcessing
      End Sub 'SetFormActivateNowProcessing
      
      
      '/ <summary>
      '/ Set the form for a user to enter a product key.
      '/ </summary>
      Private Sub SetFormActivateNow()
         HideMiddlePanelControls()
         
         'Set the label text and center
         'this.headerLabel.Text = "Enter a Product Key";
         Me.Name = "Enter a Product Key"
         'CenterLabel(headerLabel);
            Me.BackgroundImage = My.Resources.Resource1.enter_key
         
         '/Add the label to display status text to the user
         Dim activatingLabel = New Label()
         activatingLabel.Anchor = System.Windows.Forms.AnchorStyles.None
         activatingLabel.Location = New System.Drawing.Point(170, 105)
         activatingLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         activatingLabel.Name = "processingLabel"
         activatingLabel.AutoSize = True
         activatingLabel.Text = "Please enter your product key below:"
         activatingLabel.Size = New System.Drawing.Size(150, 20)
         activatingLabel.Visible = True
         Me.middlePanel.Controls.Add(activatingLabel)
         
         '/If a product key entry box already exists remove it.
         If middlePanel.Controls.IndexOfKey("productKey") >= 0 Then
            middlePanel.Controls.RemoveByKey("productKey")
         End If
         
         '/Add a product key entry box to the middle panel control.
            Dim productKey As New TextBox()
         productKey.Anchor = System.Windows.Forms.AnchorStyles.None
         productKey.Location = New System.Drawing.Point(170, 130)
         productKey.Name = "productKey"
         productKey.Size = New System.Drawing.Size(240, 45)
         productKey.Visible = True
         productKey.MaxLength = 50
         Me.middlePanel.Controls.Add(productKey)
         
         '/Add the event handler that monitors the user text input length and enables or disables
         '/the next button.
            AddHandler productKey.TextChanged, AddressOf productKey_TextChanged
         
         '/Set the button states.
         back.Enabled = True
         cancel.Enabled = True
         [next].Enabled = False
         
         '/Set the form state
         m_eFormState = Formstate.ActivateNow
      End Sub 'SetFormActivateNow
      
      
      '/ <summary>
      '/ Displays the registration form and then closes the form
      '/ </summary>
      Private Sub DisplayRegistrationForm()
         Dim register As New RegisterForm()
         Me.Visible = False
         register.ShowDialog(Me.Owner)
         Me.Close()
      End Sub 'DisplayRegistrationForm
      
      
      '/ <summary>
      '/ In case of a processing failure set the form state and display the failure message to the user.
      '/ </summary>
      '/ <param name="failureMessage">The failure message to display to the user.</param>
        Private Sub SetFormBuyNowProcessingFailed(ByVal failureInfo As Client.SSK.SSKClient.UIHelper.FailureInfo)
            HideMiddlePanelControls()

            '/If the user was trying to purchase a product key.
            If m_eFormState = Formstate.Buynowprocessing Then
                Dim failureLabel = New TextBox()
                failureLabel.Anchor = System.Windows.Forms.AnchorStyles.None
                failureLabel.Location = New System.Drawing.Point(170, 105)
                failureLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
                failureLabel.Name = "failureLabel"
                failureLabel.ReadOnly = True
                failureLabel.Multiline = True
                failureLabel.BackColor = Color.White
                failureLabel.BorderStyle = BorderStyle.None
                failureLabel.AutoSize = True
                failureLabel.TabStop = False
                failureLabel.Text = "There was a problem with your product activation. " + failureInfo.Message

                grfx = Me.CreateGraphics()
                Dim sizef As SizeF = grfx.MeasureString(failureLabel.Text, failureLabel.Font, 300)
                failureLabel.Size = New System.Drawing.Size(300, CInt(sizef.Height) + 50)


                failureLabel.Visible = True
                Me.middlePanel.Controls.Add(failureLabel)


                cancel.Text = "Close"
                back.Enabled = False
                cancel.Focus()
                m_eFormState = Formstate.BuyNowError

                If failureInfo.Alert = failureInfo.AlertType.Port Then
                    MessageBox.Show(("If the web service cannot be reached please " + "verify that the ASP .NET development port matches the port " + "configured in the application web reference and update as " + "necessary.  The application will need to be restarted after " + "the configuration change."))
                End If
            End If


            '/If the user was trying to enter a product key.
            If m_eFormState = Formstate.ActivateNowProcessing Then
                SetFormActivateNow()
                failureInfo.Message = "There was a problem with your product activation. " + failureInfo.Message
                Me.errorProvider1.SetError(Me.middlePanel.Controls.Find("productKey", False)(0), failureInfo.Message)
                back.Enabled = True
                m_eFormState = Formstate.ActivateNowError
            End If


            Me.BackgroundImage = My.Resources.Resource1.activation_unsuccessful
            Me.Name = "Activation Unsuccesful"


            'set the button states
            [next].Enabled = False
            cancel.Enabled = True
        End Sub 'SetFormBuyNowProcessingFailed
       
      
      '/<summary>
      '/ When the processing is complete and successful set the form state to a successful completion
      '/ and display the completion message.
      '/ </summary>
      '/ <param name="message">The completion message to display to the user.</param>
      Private Sub SetFormBuyNowProcessingComplete(message As String)
         HideMiddlePanelControls()
         
         '/Set the header text for the form and center
         'this.headerLabel.Text = "Activation Complete";
         Me.Name = "Activation Complete"
         'CenterLabel(headerLabel);
            Me.BackgroundImage = My.Resources.Resource1.activation_complete
         
         '/Add the control to display the form completion text
         Dim completionLabel = New Label()
         completionLabel.Anchor = System.Windows.Forms.AnchorStyles.None
         completionLabel.Location = New System.Drawing.Point(170, 105)
         completionLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         completionLabel.Name = "completionLabel"
         completionLabel.AutoSize = True
         completionLabel.Text = message
         completionLabel.Size = New System.Drawing.Size(150, 100)
         completionLabel.Visible = True
         Me.middlePanel.Controls.Add(completionLabel)
         CenterLabel(completionLabel)
         
            Dim registerButton As New Button
         registerButton.Location = New System.Drawing.Point(170, 140)
         registerButton.Name = "next"
         registerButton.Size = New System.Drawing.Size(120, 23)
         registerButton.TabIndex = 1
         registerButton.Text = "Register"
         AddHandler registerButton.Click, AddressOf Me.next_Click
         Me.middlePanel.Controls.Add(registerButton)
         
         '/Set the button states
         'next.Enabled = true;
         'next.Text = "Register";
         cancel.Enabled = True
         cancel.Text = "Close"
         back.Enabled = False
         
         '/Set the form state
         m_eFormState = Formstate.Buynowprocessingcomplete
      End Sub 'SetFormBuyNowProcessingComplete
       
      
      
      '/ <summary>
      '/ This function will center a label based on it's parent control and the text width in the label.
      '/ </summary>
      '/ <param name="label">The label to be centered.</param>
      Private Sub CenterLabel(label As System.Windows.Forms.Label)
         Dim grfx As Graphics = CreateGraphics()
         Dim sizef As SizeF = grfx.MeasureString(label.Text, label.Font)
         label.Location = New System.Drawing.Point((label.Parent.Width - Convert.ToInt32(sizef.Width)) / 2, label.Location.Y)
      End Sub 'CenterLabel
       
      
      '/ <summary>
      '/ This function hides all controls in the middle panel of the form.
      '/ </summary>
      Private Sub HideMiddlePanelControls()
         Dim c As Control
         For Each c In  Me.middlePanel.Controls
            c.Visible = False
         Next c
      End Sub 'HideMiddlePanelControls
      
      #End Region
   End Class 'BuyNowForm 
End Namespace 'SSK.SSKClient.SSKForms 