
'Shareware Starter Kit --ExceptionForm
'Summary:  This is the default form provided for the exception handling experience.
'Author: Brian Trautman briant@personifydesign.com
'Date Created: 4/11/2004
'Date Last Modified: 4/13/2005
'
'ToDo: Error processing original source shown below
'
'#region using directives
'-^--- expression expected
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports Client.SSK.SSKClient.ClientStorage
Imports Client.SSK.SSKClient.UIHelper


'
'ToDo: Error processing original source shown below
'using SSK.SSKClient.UIHelper;
'#endregion
'-^--- expression expected

Namespace SSK.SSKClient.SSKForms
   '/ <summary>
   '/ The exception form can be launched when an exception is caught.  The form allows the user to
   '/ view and then submit this information to the server database through the project web service.
   '/ </summary>
   
   Public Class ExceptionForm
      Inherits System.Windows.Forms.Form
      #Region "private variables"
      
      Private WithEvents submit As System.Windows.Forms.Button
      Private WithEvents cancel As System.Windows.Forms.Button
      Private components As System.ComponentModel.Container = Nothing
      Private message As String
      Private [source] As String
      Private stacktrace As String
      Private methodname As String
      Private errorReportLabel As Label
      Private errorDescription As TextBox
      Private statusText As TextBox
      Private sp As Serverprocessing
      Private dataStore As DataStore
      #End Region
      
      
      '/ <summary>
      '/ constructor for the exception submission form
      '/ </summary>
      '/ <param name="messageIn">The exception message.</param>
      '/ <param name="sourceIn">The exception source.</param>
      '/ <param name="stackTraceIn">The exception stacktrace.</param>
      '/ <param name="methodNameIn">The method that threw the exception.</param>
      Public Sub New(messageIn As String, sourceIn As String, stackTraceIn As String, methodNameIn As String)
         '
         ' Required for Windows Form Designer support
         '
         InitializeComponent()
         
         message = messageIn
         [source] = sourceIn
         stacktrace = stackTraceIn
         methodname = methodNameIn
         
         Dim displayText As String
         
         displayText = "Message: " + message + ControlChars.Cr + ControlChars.Lf + ControlChars.Cr + ControlChars.Lf + ControlChars.Cr + ControlChars.Lf
         displayText += "Source: " + [source] + ControlChars.Cr + ControlChars.Lf + ControlChars.Cr + ControlChars.Lf + ControlChars.Cr + ControlChars.Lf
         displayText += "StackTrace: " + stacktrace + ControlChars.Cr + ControlChars.Lf + ControlChars.Cr + ControlChars.Lf + ControlChars.Cr + ControlChars.Lf
         displayText += "MethodName: " + methodname + ControlChars.Cr + ControlChars.Lf + ControlChars.Cr + ControlChars.Lf + ControlChars.Cr + ControlChars.Lf
         
         Me.errorDescription.Text = displayText
         
         dataStore = New DataStore(Me)
         
         If dataStore.PaymentSettings Is Nothing Then
            
            Dim dataStoreMessage As String = "You Cannot use this form until a valid datastore has been received from the web service."
            MessageBox.Show(dataStoreMessage)
            Me.Close()
                Throw New Client.DataStoreAppConfigException(message)
         End If
      End Sub 'New
       
      
      '/ <summary>
      '/ Clean up any resources being used.
      '/ </summary>
      Protected Overrides Sub Dispose(disposing As Boolean)
         If disposing Then
            If Not (components Is Nothing) Then
               components.Dispose()
            End If
         End If
         MyBase.Dispose(disposing)
      End Sub 'Dispose
      
      #Region "Windows Form Designer generated code"
      
      '/ <summary>
      '/ Required method for Designer support - do not modify
      '/ the contents of this method with the code editor.
      '/ </summary>
      Private Sub InitializeComponent()
         Me.submit = New System.Windows.Forms.Button()
         Me.cancel = New System.Windows.Forms.Button()
         Me.errorReportLabel = New System.Windows.Forms.Label()
         Me.errorDescription = New System.Windows.Forms.TextBox()
         Me.statusText = New System.Windows.Forms.TextBox()
         Me.SuspendLayout()
         ' 
         ' submit
         ' 
         Me.submit.AutoSize = True
         Me.submit.FlatStyle = System.Windows.Forms.FlatStyle.System
         Me.submit.Location = New System.Drawing.Point(210, 381)
         Me.submit.Name = "submit"
         Me.submit.Size = New System.Drawing.Size(75, 23)
         Me.submit.TabIndex = 3
         Me.submit.Text = "Submit"
         ' 
         ' cancel
         ' 
         Me.cancel.AutoSize = True
         Me.cancel.FlatStyle = System.Windows.Forms.FlatStyle.System
         Me.cancel.Location = New System.Drawing.Point(426, 381)
         Me.cancel.Name = "cancel"
         Me.cancel.Size = New System.Drawing.Size(75, 23)
         Me.cancel.TabIndex = 4
         Me.cancel.Text = "Cancel"
         ' 
         ' errorReportLabel
         ' 
         Me.errorReportLabel.AutoSize = True
         Me.errorReportLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.errorReportLabel.Location = New System.Drawing.Point(170, 32)
         Me.errorReportLabel.Name = "errorReportLabel"
         Me.errorReportLabel.Size = New System.Drawing.Size(89, 16)
         Me.errorReportLabel.TabIndex = 6
         Me.errorReportLabel.Text = "Error Report"
         ' 
         ' errorDescription
         ' 
         Me.errorDescription.Location = New System.Drawing.Point(172, 153)
         Me.errorDescription.Multiline = True
         Me.errorDescription.Name = "errorDescription"
         Me.errorDescription.ReadOnly = True
         Me.errorDescription.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
         Me.errorDescription.Size = New System.Drawing.Size(364, 209)
         Me.errorDescription.TabIndex = 7
         ' 
         ' statusText
         ' 
         Me.statusText.Anchor = System.Windows.Forms.AnchorStyles.None
         Me.statusText.BackColor = System.Drawing.Color.White
         Me.statusText.BorderStyle = System.Windows.Forms.BorderStyle.None
         Me.statusText.Font = New System.Drawing.Font("Tahoma", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.statusText.Location = New System.Drawing.Point(170, 73)
         Me.statusText.Multiline = True
         Me.statusText.Name = "statusText"
         Me.statusText.ReadOnly = True
         Me.statusText.Size = New System.Drawing.Size(361, 48)
         Me.statusText.TabStop = False
         Me.statusText.Text = "This application has experienced a problem.  If you would like to submit this inf" + "ormation directly to the application developer please click the submit button be" + "low."
         ' 
         ' ExceptionForm
         ' 
         Me.BackColor = System.Drawing.Color.White
            Me.BackgroundImage = My.Resources.Resource1.error_report
         Me.ClientSize = New System.Drawing.Size(570, 416)
         Me.Controls.Add(statusText)
         Me.Controls.Add(errorDescription)
         Me.Controls.Add(errorReportLabel)
         Me.Controls.Add(cancel)
         Me.Controls.Add(submit)
         Me.Name = "ExceptionForm"
         Me.ShowInTaskbar = False
         Me.Text = "ExceptionForm"
         Me.ResumeLayout(False)
         Me.PerformLayout()
      End Sub 'InitializeComponent 
      
      
      #End Region
      
      
      
      '/ <summary>
      '/ Handle the cancel button click.
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub cancel_Click(sender As Object, e As System.EventArgs) Handles cancel.Click
         Me.Close()
      End Sub 'cancel_Click
      
      
      '/ <summary>
      '/ Handle the submit button click.
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub submit_Click(sender As Object, e As System.EventArgs) Handles submit.Click
         Me.submit.Enabled = False
         Me.errorDescription.Visible = False
         
         
         statusText.Text = "Your error report is being submitted.  This may take a few moments."
         Dim grfx As Graphics = Me.CreateGraphics()
         Dim sizef As SizeF = grfx.MeasureString(statusText.Text, statusText.Font, 300)
         statusText.Width = 350
         statusText.Height = Convert.ToInt32(sizef.Height) + 50
         statusText.Location = New Point(170,(Me.Height - statusText.Height) / 2)
         
         
         
         Dim exceptionInfo As New ExceptionInfo(message, [source], stacktrace, methodname, dataStore.ProductName, dataStore.Devtoken, dataStore.UniqueMachineID, dataStore.GetLicenseLevel.LicenseLevel, Me)
         
         'initialize the class that handles the web service interaction.
         sp = New Serverprocessing(exceptionInfo)
         
         'set up the event handlers for processing complete and failed events
            AddHandler sp.Processingcomplete, AddressOf Me.ExceptionForm_ProccessingComplete
         'ToDo: Error processing original source shown below
         '            //set up the event handlers for processing complete and failed events
         '            sp.Processingcomplete += new EventHandler<ProcessingCompletedEvent>(this.ExceptionForm_ProccessingComplete);
         '------------------------------------------------------^--- Syntax error: '(' expected
         '
         'ToDo: Error processing original source shown below
         '            //set up the event handlers for processing complete and failed events
         '            sp.Processingcomplete += new EventHandler<ProcessingCompletedEvent>(this.ExceptionForm_ProccessingComplete);
         '------------------------------------------------------------------------------------------------------------------------^--- Syntax error: ')' expected
            AddHandler sp.Processingfailed, AddressOf Me.ExceptionForm_ProccessingFailed
         'ToDo: Error processing original source shown below
         '            sp.Processingcomplete += new EventHandler<ProcessingCompletedEvent>(this.ExceptionForm_ProccessingComplete);
         '   sp.Processingfailed += new EventHandler<ProcessingFailedEvent>(this.ExceptionForm_ProccessingFailed);
         '-------------------------------------------^--- Syntax error: '(' expected
         '
         'ToDo: Error processing original source shown below
         '            sp.Processingcomplete += new EventHandler<ProcessingCompletedEvent>(this.ExceptionForm_ProccessingComplete);
         '   sp.Processingfailed += new EventHandler<ProcessingFailedEvent>(this.ExceptionForm_ProccessingFailed);
         '--------------------------------------------------------------------------------------------------------^--- Syntax error: ')' expected
         
         'proceed with the web service execution
         sp.HandleException()
      End Sub 'submit_Click
       
      
      
      '/ <summary>
      '/ This is a required method to use the server processing class.  This gets called
      '/ via an event from server processing to signal the UI that the processing is complete.
      '/ 
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub ExceptionForm_ProccessingComplete(sender As Object, e As ProcessingCompletedEvent)
         ' Map the delegate to the instance method:
            Dim d As New MarshallThisFuncString(AddressOf SetExceptionProcessingComplete)
         e.FormReference.Invoke(d, New Object() {e.Message})
      End Sub 'ExceptionForm_ProccessingComplete
       
      
      '/ <summary>
      '/ Set the form to a complete state signifying successful processing.
      '/ </summary>
      '/ <param name="message"></param>
      Private Sub SetExceptionProcessingComplete(message As String)
         statusText.Text = message
         Dim grfx As Graphics = Me.CreateGraphics()
         Dim sizef As SizeF = grfx.MeasureString(statusText.Text, statusText.Font, 300)
         statusText.Width = 350
         statusText.Height = Convert.ToInt32(sizef.Height) + 50
         statusText.Location = New Point(170,(Me.Height - statusText.Height) / 2)
         
         submit.Enabled = False
         cancel.Text = "Close"
      End Sub 'SetExceptionProcessingComplete
      
      
      
      
      '/ <summary>
      '/ This is a required method to use the server processing class.  Serverprocessing 
      '/ communicates with the submit exception web service and notifies the client with
      '/ Error message via the ProcessingFailedEventArgs
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub ExceptionForm_ProccessingFailed(sender As Object, e As ProcessingFailedEvent)
         ' Map the delegate to the instance method:
            Dim d As New MarshallThisFuncFailureInfo(AddressOf SetExceptionProcessingFailed)
         e.FormReference.Invoke(d, New Object() {e.FailureInformation})
      End Sub 'ExceptionForm_ProccessingFailed
       
      
      Private Sub SetExceptionProcessingFailed(failureInfo As FailureInfo)
         statusText.Text = failureInfo.Message
         Dim grfx As Graphics = Me.CreateGraphics()
         Dim sizef As SizeF = grfx.MeasureString(statusText.Text, statusText.Font, 300)
         statusText.Width = 350
         statusText.Height = Convert.ToInt32(sizef.Height) + 50
         statusText.Location = New Point(170,(Me.Height - statusText.Height) / 2)
         
         
         submit.Enabled = False
         cancel.Text = "Close"
         
         If failureInfo.Alert = FailureInfo.AlertType.Port Then
            MessageBox.Show(("If the web service cannot be reached please " + "verify that the ASP .NET development port matches the port " + "configured in the application web reference and update as " + "necessary.  The application will need to be restarted after " + "the configuration change."))
         End If
      End Sub 'SetExceptionProcessingFailed
      
      
      
      Sub ExceptionForm_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
         If Not (sp Is Nothing) Then
            sp.Cancelprocessing()
         End If
      End Sub 'ExceptionForm_FormClosing
      
      
      Private Sub ExceptionForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
      End Sub 'ExceptionForm_Load
   End Class 'ExceptionForm 
End Namespace 'SSK.SSKClient.SSKForms

