
'Shareware Starter Kit --FeedbackForm
'Summary:  This is the default form provided for the feedback submission experience.
'Author: Brian Trautman briant@personifydesign.com
'Date Created: 4/11/2004
'Date Last Modified: 4/13/2005
'
'ToDo: Error processing original source shown below
'
'#region using directives
'-^--- expression expected
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Threading
Imports Client.SSK.SSKClient.UIHelper
Imports Client.SSK.SSKClient.ClientStorage

'
'ToDo: Error processing original source shown below
'using SSK.SSKClient.ClientStorage;
'#endregion
'-^--- expression expected

Namespace SSK.SSKClient.SSKForms
   '/ <summary>
   '/ Summary description for FeedbackForm.
   '/ </summary>
   '/ <exception cref="DataStoreAppConfigException">
   '/ If the datastore has not been initialized before the form was created this exception will be thrown.
   '/ </exception>
   
   Public Class FeedbackForm
      Inherits System.Windows.Forms.Form
      #Region "private form variables"
      
      Private richTextBox1 As System.Windows.Forms.RichTextBox
      Private WithEvents submit As System.Windows.Forms.Button
      Private errNotifier As System.Windows.Forms.ErrorProvider
      Private email As System.Windows.Forms.TextBox
      Private lastname As System.Windows.Forms.TextBox
      Private firstname As System.Windows.Forms.TextBox
      Private firstNameLabel As System.Windows.Forms.Label
      Private lastNameLabel As System.Windows.Forms.Label
      Private emailLabel As System.Windows.Forms.Label
      Private grfx As Graphics
      Private sp As Serverprocessing
      Private dataStore As DataStore
      
      '/ <summary>
      '/ Required designer variable.
      '/ </summary>
      Private components As System.ComponentModel.Container = Nothing
      Private richTextLabel As System.Windows.Forms.Label
      
      'holds the status of the form (Error, submitted, etc)
      Private _status As String
      
      #End Region
      
      #Region "constructor"
      
      '/ <summary>
      '/ Constructor for the feedback form
      '/ </summary>
      '/ <exception cref="DataStoreAppConfigException">
      '/ If the datastore has not been initialized before the form was created this exception will be thrown.
      '/ </exception>
      Public Sub New()
         '
         ' Required for Windows Form Designer support
         '
         InitializeComponent()
         Me.errNotifier = New System.Windows.Forms.ErrorProvider()
         dataStore = New DataStore(Me)
         
         If dataStore.PaymentSettings Is Nothing Then
            
            Dim message As String = "You Cannot use this form until a valid datastore has been received from the web service."
            MessageBox.Show(message)
            Me.Close()
                Throw New Client.DataStoreAppConfigException(message)
         End If
      End Sub 'New
      #End Region
      
      #Region "dispose"
      
      '/ <summary>
      '/ Clean up any resources being used.
      '/ </summary>
      Protected Overrides Sub Dispose(disposing As Boolean)
         If disposing Then
            If Not (components Is Nothing) Then
               components.Dispose()
            End If
            sp.Dispose()
         End If
         MyBase.Dispose(disposing)
      End Sub 'Dispose
      #End Region
      
      #Region "Windows Form Designer generated code"
      
      '/ <summary>
      '/ Required method for Designer support - do not modify
      '/ the contents of this method with the code editor.
      '/ </summary>
      Private Sub InitializeComponent()
         Me.richTextBox1 = New System.Windows.Forms.RichTextBox()
         Me.submit = New System.Windows.Forms.Button()
         Me.firstname = New System.Windows.Forms.TextBox()
         Me.lastname = New System.Windows.Forms.TextBox()
         Me.email = New System.Windows.Forms.TextBox()
         Me.firstNameLabel = New System.Windows.Forms.Label()
         Me.lastNameLabel = New System.Windows.Forms.Label()
         Me.emailLabel = New System.Windows.Forms.Label()
         Me.richTextLabel = New System.Windows.Forms.Label()
         Me.SuspendLayout()
         ' 
         ' richTextBox1
         ' 
         Me.richTextBox1.AutoSize = True
         Me.richTextBox1.BackColor = System.Drawing.Color.LightGray
         Me.richTextBox1.Location = New System.Drawing.Point(170, 224)
         Me.richTextBox1.MaxLength = 1024
         Me.richTextBox1.Name = "richTextBox1"
         Me.richTextBox1.Size = New System.Drawing.Size(370, 104)
         Me.richTextBox1.TabIndex = 4
         Me.richTextBox1.Text = ""
         ' 
         ' submit
         ' 
         Me.submit.AutoSize = True
         Me.submit.FlatStyle = System.Windows.Forms.FlatStyle.System
         Me.submit.Location = New System.Drawing.Point(297, 357)
         Me.submit.Name = "submit"
         Me.submit.Size = New System.Drawing.Size(114, 23)
         Me.submit.TabIndex = 5
         Me.submit.Text = "Submit"
         ' 
         ' firstname
         ' 
         Me.firstname.BackColor = System.Drawing.Color.LightGray
         Me.firstname.Location = New System.Drawing.Point(170, 112)
         Me.firstname.MaxLength = 32
         Me.firstname.Name = "firstname"
         Me.firstname.Size = New System.Drawing.Size(175, 20)
         Me.firstname.TabIndex = 0
         ' 
         ' lastname
         ' 
         Me.lastname.BackColor = System.Drawing.Color.LightGray
         Me.lastname.Location = New System.Drawing.Point(365, 112)
         Me.lastname.MaxLength = 32
         Me.lastname.Name = "lastname"
         Me.lastname.Size = New System.Drawing.Size(175, 20)
         Me.lastname.TabIndex = 1
         ' 
         ' email
         ' 
         Me.email.BackColor = System.Drawing.Color.LightGray
         Me.email.Location = New System.Drawing.Point(170, 168)
         Me.email.MaxLength = 32
         Me.email.Name = "email"
         Me.email.Size = New System.Drawing.Size(175, 20)
         Me.email.TabIndex = 3
         ' 
         ' firstNameLabel
         ' 
         Me.firstNameLabel.AutoSize = True
         Me.firstNameLabel.BackColor = System.Drawing.Color.Transparent
         Me.firstNameLabel.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.firstNameLabel.Location = New System.Drawing.Point(170, 88)
         Me.firstNameLabel.Name = "firstNameLabel"
         Me.firstNameLabel.Size = New System.Drawing.Size(58, 13)
         Me.firstNameLabel.TabIndex = 7
         Me.firstNameLabel.Text = "First Name:"
         ' 
         ' lastNameLabel
         ' 
         Me.lastNameLabel.AutoSize = True
         Me.lastNameLabel.BackColor = System.Drawing.Color.Transparent
         Me.lastNameLabel.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.lastNameLabel.Location = New System.Drawing.Point(367, 88)
         Me.lastNameLabel.Name = "lastNameLabel"
         Me.lastNameLabel.Size = New System.Drawing.Size(57, 13)
         Me.lastNameLabel.TabIndex = 8
         Me.lastNameLabel.Text = "Last Name:"
         ' 
         ' emailLabel
         ' 
         Me.emailLabel.AutoSize = True
         Me.emailLabel.BackColor = System.Drawing.Color.Transparent
         Me.emailLabel.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.emailLabel.Location = New System.Drawing.Point(170, 144)
         Me.emailLabel.Name = "emailLabel"
         Me.emailLabel.Size = New System.Drawing.Size(35, 13)
         Me.emailLabel.TabIndex = 9
         Me.emailLabel.Text = "E-mail:"
         ' 
         ' richTextLabel
         ' 
         Me.richTextLabel.AutoSize = True
         Me.richTextLabel.BackColor = System.Drawing.Color.Transparent
         Me.richTextLabel.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.richTextLabel.Location = New System.Drawing.Point(237, 200)
         Me.richTextLabel.Name = "richTextLabel"
         Me.richTextLabel.Size = New System.Drawing.Size(201, 13)
         Me.richTextLabel.TabIndex = 10
         Me.richTextLabel.Text = "Product Feedback (max 1024 characters)"
         ' 
         ' FeedbackForm
         ' 
         Me.AcceptButton = Me.submit
         Me.BackColor = System.Drawing.Color.Silver
            Me.BackgroundImage = My.Resources.Resource1.feedback
         Me.ClientSize = New System.Drawing.Size(570, 416)
         Me.Controls.Add(richTextLabel)
         Me.Controls.Add(emailLabel)
         Me.Controls.Add(lastNameLabel)
         Me.Controls.Add(firstNameLabel)
         Me.Controls.Add(email)
         Me.Controls.Add(lastname)
         Me.Controls.Add(firstname)
         Me.Controls.Add(submit)
         Me.Controls.Add(richTextBox1)
         Me.Name = "FeedbackForm"
         Me.ShowInTaskbar = False
         Me.Text = "FeedbackForm"
         Me.ResumeLayout(False)
         Me.PerformLayout()
      End Sub 'InitializeComponent 
      
      
      
      
      #End Region
      
      #Region "form validation"
      
      '/ <summary>
      '/ used to validate each entry box on the form
      '/ </summary>
      '/ <param name="control"></param>
      '/ <returns></returns>
      Private Function ValidateField(control As Control) As Boolean
         Dim validator As FormValidator.ControlValidator
         
         If control.Name = "email" Then
                validator = New FormValidator.ControlValidator(AddressOf FormValidator.Isemailvalidator)
         Else
                validator = New FormValidator.ControlValidator(AddressOf FormValidator.Hastextvalidator)
         End If
         
         Return FormValidator.Fieldisvalid(Me.errNotifier, control, "Required Field", validator)
      End Function 'ValidateField
      #End Region
      
      #Region "feedback form event handling"
      
      
      
      
      Private Sub FeedbackForm_Load(sender As Object, e As System.EventArgs) Handles MyBase.Load
      End Sub 'FeedbackForm_Load
      
      
      
      '/ <summary>
      '/ This is a required method to use the server processing class.  This gets called
      '/ via an event from server processing to signal the UI that the processing is complete.
      '/ 
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub FeedbackForm_ProccessingComplete(sender As Object, e As ProcessingCompletedEvent)
         
         ' Map the delegate to the instance method:
            Dim d As New MarshallThisFuncString(AddressOf SetFeedbackProcessingComplete)
         e.FormReference.Invoke(d, New Object() {e.Message})
      End Sub 'FeedbackForm_ProccessingComplete
       
      
      '/ <summary>
      '/ Set the form state for processing complete and display the completion message.
      '/ </summary>
      '/ <param name="message">The completion message.</param>
      Private Sub SetFeedbackProcessingComplete(message As String)
         
         Dim c As Control
         For Each c In  Me.Controls
            If c.Name = "statusText" Then
               Me.Controls.Remove(c)
                    Exit For
            End If
         Next c
         
         Dim statusText As New TextBox()
         statusText.Multiline = True
         statusText.BorderStyle = BorderStyle.None
         statusText.ReadOnly = True
         statusText.TabStop = False
         statusText.BackColor = Color.White
         statusText.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         statusText.Name = "statusText"
         statusText.Text = message
         Dim grfx As Graphics = Me.CreateGraphics()
         Dim sizef As SizeF = grfx.MeasureString(statusText.Text, statusText.Font, 300)
         statusText.Width = 350
         statusText.Height = Convert.ToInt32(sizef.Height) + 50
         statusText.Location = New Point(170,(Me.Height - statusText.Height) / 2)
         Me.submit.Enabled = False
         Me.Controls.Add(statusText)
         
         Me.submit.Enabled = True
         Me.submit.Text = "Finish"
         
         Me.submit.Focus()
      End Sub 'SetFeedbackProcessingComplete
      
      
      '/ <summary>
      '/ This is a required method to use the server processing class.  Serverprocessing 
      '/ communicates with the submit feedback web service and notifies the client with
      '/ Error message via the ProcessingFailedEventArgs
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub FeedbackForm_ProccessingFailed(sender As Object, e As ProcessingFailedEvent)
         ' Map the delegate to the instance method:
            Dim d As New MarshallThisFuncFailureInfo(AddressOf SetFeedbackProcessingFailed)
         e.FormReference.Invoke(d, New Object() {e.FailureInformation})
      End Sub 'FeedbackForm_ProccessingFailed
       
      
      '/ <summary>
      '/ Set the form for processing failed and display the failure message.
      '/ </summary>
      '/ <param name="message">The failure message to display to the user.</param>
      Private Sub SetFeedbackProcessingFailed(failureInfo As FailureInfo)
         
         _status = "Error"
         Dim c As Control
         For Each c In  Me.Controls
            If c.Name = "statusText" Then
               Me.Controls.Remove(c)
                    Exit For
            End If
         Next c
         
         Dim statusText As New TextBox()
         statusText.Multiline = True
         statusText.BorderStyle = BorderStyle.None
         statusText.ReadOnly = True
         statusText.TabStop = False
         statusText.BackColor = Color.White
         statusText.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         statusText.Name = "statusText"
         statusText.Text = failureInfo.Message
         Dim grfx As Graphics = Me.CreateGraphics()
         Dim sizef As SizeF = grfx.MeasureString(statusText.Text, statusText.Font, 300)
         statusText.Width = 350
         statusText.Height = Convert.ToInt32(sizef.Height) + 50
         statusText.Location = New Point(170,(Me.Height - statusText.Height) / 2)
         Me.submit.Enabled = False
         Me.Controls.Add(statusText)
         
         Me.submit.Enabled = True
         Me.submit.Text = "Finish"
         Me.submit.Focus()
         
         If failureInfo.Alert = FailureInfo.AlertType.Port Then
            MessageBox.Show(("If the web service cannot be reached please " + "verify that the ASP .NET development port matches the port " + "configured in the application web reference and update as " + "necessary.  The application will need to be restarted after " + "the configuration change."))
         End If
      End Sub 'SetFeedbackProcessingFailed
      
      
      
      '/ <summary>
      '/ Handles the submit click event.  If form input validation is successful 
      '/ server processing is contacted and info submitted via the submit feedback
      '/ web service
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub submit_Click(sender As Object, e As System.EventArgs) Handles submit.Click
         If _status = "submitted" OrElse _status = "Error" Then
            Me.Close()
         Else
            'first validate name and email fields to see if they are populated.  We do this because the IF statement
            'below will only run the first validation if it fails right there, and we want to validate all three fields
            'no matter what
            ValidateField(Me.firstname)
            ValidateField(Me.lastname)
            ValidateField(Me.email)
            ValidateField(Me.richTextBox1)
            
            'if all the form inputs are valid then proceed with server processing
            If ValidateField(Me.firstname) AndAlso ValidateField(Me.lastname) AndAlso ValidateField(Me.email) AndAlso ValidateField(Me.richTextBox1) Then
               
               _status = "submitted"
               Me.firstname.Visible = False
               Me.lastname.Visible = False
               Me.email.Visible = False
               Me.firstNameLabel.Visible = False
               Me.lastNameLabel.Visible = False
               Me.emailLabel.Visible = False
               Me.richTextLabel.Visible = False
               Me.richTextBox1.Visible = False
               
               Dim statusText As New TextBox()
               statusText.Multiline = True
               statusText.BorderStyle = BorderStyle.None
               statusText.ReadOnly = True
               statusText.TabStop = False
               statusText.BackColor = Color.White
               statusText.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
               statusText.Name = "statusText"
               statusText.Text = "Your feedback is being processed.  This may take a few moments."
               Dim grfx As Graphics = Me.CreateGraphics()
               Dim sizef As SizeF = grfx.MeasureString(statusText.Text, statusText.Font, 300)
               statusText.Width = 350
               statusText.Height = Convert.ToInt32(sizef.Height) + 50
               statusText.Location = New Point(170,(Me.Height - statusText.Height) / 2)
               Me.submit.Enabled = False
               Me.Controls.Add(statusText)
               
               
               Me.submit.Enabled = False
               
               
               Dim feedbackInfo As New FeedbackInfo(dataStore.ProductName, dataStore.GetLicenseLevel.LicenseLevel, Me.email.Text, Me.firstname.Text, Me.lastname.Text, Me.richTextBox1.Text, dataStore.Devtoken, Me)
               
               
               
               'Create new serverProcessing class to handle web service calls
               sp = New Serverprocessing(feedbackInfo)
               
               'set up the event handlers for processing failed and complete
                    AddHandler sp.Processingcomplete, AddressOf Me.FeedbackForm_ProccessingComplete '
                    AddHandler sp.Processingfailed, AddressOf Me.FeedbackForm_ProccessingFailed '

               'start the web service on a seperate thread
                    Dim handleProcessingThreadStarter As New ThreadStart(AddressOf sp.HandleFeedback)
               Dim handleProcessingThread As New Thread(handleProcessingThreadStarter)
               handleProcessingThread.Start()
            End If 
         End If
      End Sub 'submit_Click
      
      
      
      Sub FeedbackForm_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
         If Not (sp Is Nothing) Then
            sp.Cancelprocessing()
         End If
      End Sub 'FeedbackForm_FormClosing
      
      #End Region
   End Class 'FeedbackForm
End Namespace 'SSK.SSKClient.SSKForms 
