 'Shareware Starter Kit --RegisterForm
'Summary:  This is the default form provided for the registration experience.
'Author: Brian Trautman briant@personifydesign.com
'Date Created: 4/11/2004
'Date Last Modified: 4/13/2005
'
'ToDo: Error processing original source shown below
'
'#region using directives
'-^--- expression expected

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports System.Threading
Imports System.Runtime.Serialization
Imports Client.SSK.SSKClient.UIHelper
Imports Client.SSK.SSKClient.ClientStorage

'
'ToDo: Error processing original source shown below
'using SSK.SSKClient.ClientStorage;
'#endregion
'-^--- expression expected

Namespace SSK.SSKClient.SSKForms
   
   '/ <summary>
   '/ Summary description for Form1.
   '/ </summary>
   '/ <exception cref="DataStoreAppConfigException">
   '/ If the datastore has not been initialized before the form was created this exception will be thrown.
   '/ </exception>
   
   Public Class RegisterForm
      Inherits System.Windows.Forms.Form
      
      #Region "private form variables"
      Private WithEvents firstname As System.Windows.Forms.TextBox
      Private lastname As System.Windows.Forms.TextBox
      Private address As System.Windows.Forms.TextBox
      Private city As System.Windows.Forms.TextBox
      Private state As System.Windows.Forms.TextBox
      Private zipcode As System.Windows.Forms.TextBox
      Private phone As System.Windows.Forms.TextBox
      Private email As System.Windows.Forms.TextBox
      Private label1 As System.Windows.Forms.Label
      Private label2 As System.Windows.Forms.Label
      Private label3 As System.Windows.Forms.Label
      Private label4 As System.Windows.Forms.Label
      Private label5 As System.Windows.Forms.Label
      Private label6 As System.Windows.Forms.Label
      Private label7 As System.Windows.Forms.Label
      Private label8 As System.Windows.Forms.Label
      Private WithEvents submit As System.Windows.Forms.Button
      Private errNotifier As System.Windows.Forms.ErrorProvider
      Private sp As Serverprocessing
      Private dataStore As DataStore
      
      '/ <summary>
      '/ Required designer variable.
      '/ </summary>
      Private components As System.ComponentModel.Container = Nothing
      Private _status As String
      #End Region
      
      #Region "constructor"
      
      '/ <summary>
      '/ The constructor for the Register Form
      '/ </summary>
      '/ <exception cref="DataStoreAppConfigException">
      '/ If the datastore has not been initialized before the form was created this exception will be thrown.
      '/ </exception>
      Public Sub New()
         '
         ' Required for Windows Form Designer support
         '
         InitializeComponent()
         
         Me.errNotifier = New System.Windows.Forms.ErrorProvider()
         
         dataStore = New DataStore(Me)
         
         
         If dataStore.PaymentSettings Is Nothing Then
            
            Dim message As String = "You Cannot use this form until a valid datastore has been received from the web service."
            MessageBox.Show(message)
            Me.Close()
                Throw New Client.DataStoreAppConfigException(message)
         End If
      End Sub 'New 
      #End Region
      
      #Region "dispose"
      
      '/ <summary>
      '/ Clean up any resources being used.
      '/ </summary>
      Protected Overrides Sub Dispose(disposing As Boolean)
         If disposing Then
            If Not (components Is Nothing) Then
               components.Dispose()
            End If
            sp.Dispose()
         End If
         MyBase.Dispose(disposing)
      End Sub 'Dispose
      #End Region
      
      #Region "Windows Form Designer generated code"
      
      '/ <summary>
      '/ Required method for Designer support - do not modify
      '/ the contents of this method with the code editor.
      '/ </summary>
      Private Sub InitializeComponent()
         Me.firstname = New System.Windows.Forms.TextBox()
         Me.lastname = New System.Windows.Forms.TextBox()
         Me.address = New System.Windows.Forms.TextBox()
         Me.city = New System.Windows.Forms.TextBox()
         Me.state = New System.Windows.Forms.TextBox()
         Me.zipcode = New System.Windows.Forms.TextBox()
         Me.phone = New System.Windows.Forms.TextBox()
         Me.email = New System.Windows.Forms.TextBox()
         Me.label1 = New System.Windows.Forms.Label()
         Me.label2 = New System.Windows.Forms.Label()
         Me.label3 = New System.Windows.Forms.Label()
         Me.label4 = New System.Windows.Forms.Label()
         Me.label5 = New System.Windows.Forms.Label()
         Me.label6 = New System.Windows.Forms.Label()
         Me.label7 = New System.Windows.Forms.Label()
         Me.label8 = New System.Windows.Forms.Label()
         Me.submit = New System.Windows.Forms.Button()
         Me.SuspendLayout()
         ' 
         ' firstname
         ' 
         Me.firstname.BackColor = System.Drawing.Color.LightGray
         Me.firstname.Location = New System.Drawing.Point(170, 119)
         Me.firstname.MaxLength = 32
         Me.firstname.Name = "firstname"
         Me.firstname.Size = New System.Drawing.Size(175, 20)
         Me.firstname.TabIndex = 0
         ' 
         ' lastname
         ' 
         Me.lastname.BackColor = System.Drawing.Color.LightGray
         Me.lastname.Location = New System.Drawing.Point(361, 119)
         Me.lastname.MaxLength = 32
         Me.lastname.Name = "lastname"
         Me.lastname.Size = New System.Drawing.Size(175, 20)
         Me.lastname.TabIndex = 1
         ' 
         ' address
         ' 
         Me.address.BackColor = System.Drawing.Color.LightGray
         Me.address.Location = New System.Drawing.Point(170, 167)
         Me.address.MaxLength = 128
         Me.address.Name = "address"
         Me.address.Size = New System.Drawing.Size(366, 20)
         Me.address.TabIndex = 2
         ' 
         ' city
         ' 
         Me.city.BackColor = System.Drawing.Color.LightGray
         Me.city.Location = New System.Drawing.Point(170, 215)
         Me.city.MaxLength = 32
         Me.city.Name = "city"
         Me.city.Size = New System.Drawing.Size(175, 20)
         Me.city.TabIndex = 3
         ' 
         ' state
         ' 
         Me.state.BackColor = System.Drawing.Color.LightGray
         Me.state.Location = New System.Drawing.Point(362, 215)
         Me.state.MaxLength = 32
         Me.state.Name = "state"
         Me.state.Size = New System.Drawing.Size(56, 20)
         Me.state.TabIndex = 4
         ' 
         ' zipcode
         ' 
         Me.zipcode.BackColor = System.Drawing.Color.LightGray
         Me.zipcode.Location = New System.Drawing.Point(433, 215)
         Me.zipcode.MaxLength = 16
         Me.zipcode.Name = "zipcode"
         Me.zipcode.Size = New System.Drawing.Size(103, 20)
         Me.zipcode.TabIndex = 5
         ' 
         ' phone
         ' 
         Me.phone.BackColor = System.Drawing.Color.LightGray
         Me.phone.Location = New System.Drawing.Point(170, 271)
         Me.phone.MaxLength = 32
         Me.phone.Name = "phone"
         Me.phone.Size = New System.Drawing.Size(175, 20)
         Me.phone.TabIndex = 6
         ' 
         ' email
         ' 
         Me.email.BackColor = System.Drawing.Color.LightGray
         Me.email.Location = New System.Drawing.Point(361, 271)
         Me.email.MaxLength = 32
         Me.email.Name = "email"
         Me.email.Size = New System.Drawing.Size(175, 20)
         Me.email.TabIndex = 8
         ' 
         ' label1
         ' 
         Me.label1.AutoSize = True
         Me.label1.BackColor = System.Drawing.Color.Transparent
         Me.label1.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.label1.Location = New System.Drawing.Point(170, 100)
         Me.label1.Name = "label1"
         Me.label1.Size = New System.Drawing.Size(62, 13)
         Me.label1.TabIndex = 10
         Me.label1.Text = "First Name:"
         ' 
         ' label2
         ' 
         Me.label2.AutoSize = True
         Me.label2.BackColor = System.Drawing.Color.Transparent
         Me.label2.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.label2.Location = New System.Drawing.Point(361, 100)
         Me.label2.Name = "label2"
         Me.label2.Size = New System.Drawing.Size(61, 13)
         Me.label2.TabIndex = 11
         Me.label2.Text = "Last Name:"
         ' 
         ' label3
         ' 
         Me.label3.AutoSize = True
         Me.label3.BackColor = System.Drawing.Color.Transparent
         Me.label3.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.label3.Location = New System.Drawing.Point(170, 149)
         Me.label3.Name = "label3"
         Me.label3.Size = New System.Drawing.Size(50, 13)
         Me.label3.TabIndex = 12
         Me.label3.Text = "Address:"
         ' 
         ' label4
         ' 
         Me.label4.AutoSize = True
         Me.label4.BackColor = System.Drawing.Color.Transparent
         Me.label4.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.label4.Location = New System.Drawing.Point(168, 197)
         Me.label4.Name = "label4"
         Me.label4.Size = New System.Drawing.Size(30, 13)
         Me.label4.TabIndex = 13
         Me.label4.Text = "City:"
         ' 
         ' label5
         ' 
         Me.label5.AutoSize = True
         Me.label5.BackColor = System.Drawing.Color.Transparent
         Me.label5.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.label5.Location = New System.Drawing.Point(362, 197)
         Me.label5.Name = "label5"
         Me.label5.Size = New System.Drawing.Size(37, 13)
         Me.label5.TabIndex = 14
         Me.label5.Text = "State:"
         ' 
         ' label6
         ' 
         Me.label6.AutoSize = True
         Me.label6.BackColor = System.Drawing.Color.Transparent
         Me.label6.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.label6.Location = New System.Drawing.Point(432, 197)
         Me.label6.Name = "label6"
         Me.label6.Size = New System.Drawing.Size(53, 13)
         Me.label6.TabIndex = 15
         Me.label6.Text = "Zip Code:"
         ' 
         ' label7
         ' 
         Me.label7.AutoSize = True
         Me.label7.BackColor = System.Drawing.Color.Transparent
         Me.label7.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.label7.Location = New System.Drawing.Point(170, 250)
         Me.label7.Name = "label7"
         Me.label7.Size = New System.Drawing.Size(41, 13)
         Me.label7.TabIndex = 16
         Me.label7.Text = "Phone:"
         ' 
         ' label8
         ' 
         Me.label8.AutoSize = True
         Me.label8.BackColor = System.Drawing.Color.Transparent
         Me.label8.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         Me.label8.Location = New System.Drawing.Point(360, 251)
         Me.label8.Name = "label8"
         Me.label8.Size = New System.Drawing.Size(39, 13)
         Me.label8.TabIndex = 17
         Me.label8.Text = "E-mail:"
         ' 
         ' submit
         ' 
         Me.submit.AutoSize = True
         Me.submit.FlatStyle = System.Windows.Forms.FlatStyle.System
         Me.submit.Location = New System.Drawing.Point(296, 356)
         Me.submit.Name = "submit"
         Me.submit.Size = New System.Drawing.Size(114, 23)
         Me.submit.TabIndex = 19
         Me.submit.Text = "Submit"
         ' 
         ' RegisterForm
         ' 
         Me.AcceptButton = Me.submit
         Me.BackColor = System.Drawing.Color.Silver
            Me.BackgroundImage = My.Resources.Resource1.registration

         Me.ClientSize = New System.Drawing.Size(569, 415)
         Me.Controls.Add(submit)
         Me.Controls.Add(label8)
         Me.Controls.Add(label7)
         Me.Controls.Add(label6)
         Me.Controls.Add(label5)
         Me.Controls.Add(label4)
         Me.Controls.Add(label3)
         Me.Controls.Add(label2)
         Me.Controls.Add(label1)
         Me.Controls.Add(email)
         Me.Controls.Add(phone)
         Me.Controls.Add(zipcode)
         Me.Controls.Add(state)
         Me.Controls.Add(city)
         Me.Controls.Add(address)
         Me.Controls.Add(lastname)
         Me.Controls.Add(firstname)
         Me.Name = "RegisterForm"
         Me.ShowInTaskbar = False
         Me.Text = "Register"
         Me.ResumeLayout(False)
         Me.PerformLayout()
      End Sub 'InitializeComponent 
      
      
      #End Region
      
      #Region "form event handling"
      
      
      
      '/ <summary>
      '/ this is a required method to use the server processing class.  On successful
      '/ submission this event is fired by server processing after the web service call 
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub RegisterForm_ProccessingComplete(sender As Object, e As ProcessingCompletedEvent)
         
         ' Map the delegate to the instance method:
            Dim d As New MarshallThisFuncString(AddressOf SetRegistrationProcessingCompleted)
         
         e.FormReference.Invoke(d, New Object() {e.Message})
      End Sub 'RegisterForm_ProccessingComplete
       
      
      
      
      
      Private Sub SetRegistrationProcessingCompleted(message As String)
         Dim c As Control
         For Each c In  Me.Controls
            If c.Name = "statusText" Then
               Me.Controls.Remove(c)
                    Exit For
            End If
         Next c
         Dim statusText As New TextBox()
         statusText.Multiline = True
         statusText.BorderStyle = BorderStyle.None
         statusText.ReadOnly = True
         statusText.TabStop = False
         statusText.BackColor = Color.White
         statusText.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         statusText.Name = "statusText"
         statusText.Text = message
         Dim grfx As Graphics = Me.CreateGraphics()
         Dim sizef As SizeF = grfx.MeasureString(statusText.Text, statusText.Font, 300)
         statusText.Width = 350
         statusText.Height = Convert.ToInt32(sizef.Height) + 50
         statusText.Location = New Point(170,(Me.Height - statusText.Height) / 2)
         Me.submit.Enabled = False
         Me.Controls.Add(statusText)
         
         Me.submit.Enabled = True
         Me.submit.Text = "Finish"
      End Sub 'SetRegistrationProcessingCompleted
      
      
      '/ <summary>
      '/ This is a required method to use the server processing class.  On a web service 
      '/ failure this failure message is passed back to the client UI with ProcessingFailedEventArgs
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub RegisterForm_ProccessingFailed(sender As Object, e As ProcessingFailedEvent)
         ' Map the delegate to the instance method:
            Dim d As New MarshallThisFuncFailureInfo(AddressOf SetRegistrationProcessingFailed)
         e.FormReference.Invoke(d, New Object() {e.FailureInformation})
      End Sub 'RegisterForm_ProccessingFailed
       
      
      '/ <summary>
      '/ Set the form to a failure state and display the failure message.
      '/ </summary>
      '/ <param name="message">The failure message to display to the user.</param>
      Private Sub SetRegistrationProcessingFailed(failureInfo As FailureInfo)
         _status = "Error"
         
         Dim c As Control
         For Each c In  Me.Controls
            If c.Name = "statusText" Then
               Me.Controls.Remove(c)
                    Exit For
            End If
         Next c
         Dim statusText As New TextBox()
         statusText.Multiline = True
         statusText.BorderStyle = BorderStyle.None
         statusText.ReadOnly = True
         statusText.TabStop = False
         statusText.BackColor = Color.White
         statusText.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
         statusText.Name = "statusText"
         statusText.Text = failureInfo.Message
         Dim grfx As Graphics = Me.CreateGraphics()
         Dim sizef As SizeF = grfx.MeasureString(statusText.Text, statusText.Font, 300)
         statusText.Width = 350
         statusText.Height = Convert.ToInt32(sizef.Height) + 50
         statusText.Location = New Point(170,(Me.Height - statusText.Height) / 2)
         Me.submit.Enabled = False
         Me.Controls.Add(statusText)
         
         
         Me.submit.Enabled = True
         Me.submit.Text = "Finish"
         
         If failureInfo.Alert = FailureInfo.AlertType.Port Then
            MessageBox.Show(("If the web service cannot be reached please " + "verify that the ASP .NET development port matches the port " + "configured in the application web reference and update as " + "necessary.  The application will need to be restarted after " + "the configuration change."))
         End If
      End Sub 'SetRegistrationProcessingFailed
      
      
      
      '/ <summary>
      '/ used to validate the input on the form
      '/ </summary>
      '/ <param name="control"></param>
      '/ <returns></returns>
      Private Function ValidateField(control As Control) As Boolean
         Dim validator As FormValidator.ControlValidator
         
         If control.Name = "email" Then
                validator = New FormValidator.ControlValidator(AddressOf FormValidator.Isemailvalidator)
         Else
                validator = New FormValidator.ControlValidator(AddressOf FormValidator.Hastextvalidator)
         End If
         
         Return FormValidator.Fieldisvalid(Me.errNotifier, control, "Required Field", validator)
      End Function 'ValidateField
       
      
      '/ <summary>
      '/ If the button is clicked and the status is submitted or Error then the form is closed.
      '/ Otherwise, the UI is initialized to a processing status and the web service is contacted
      '/ via the serverProcessing class
      '/ </summary>
      '/ <param name="sender"></param>
      '/ <param name="e"></param>
      Private Sub submit_Click(sender As Object, e As System.EventArgs) Handles submit.Click
         
         
         If _status = "submitted" OrElse _status = "Error" Then
            Me.Close()
         Else
            
            'first validate name and email fields to see if they are populated.  We do this because the IF statement
            'below will only run the first validation if it fails right there, and we want to validate all three fields
            'no matter what
            ValidateField(Me.firstname)
            ValidateField(Me.lastname)
            ValidateField(Me.email)
            
            If ValidateField(Me.firstname) AndAlso ValidateField(Me.lastname) AndAlso ValidateField(Me.email) Then
               
               Me.firstname.Visible = False
               Me.lastname.Visible = False
               Me.address.Visible = False
               Me.city.Visible = False
               Me.state.Visible = False
               Me.zipcode.Visible = False
               Me.phone.Visible = False
               Me.email.Visible = False
               Me.label1.Visible = False
               Me.label2.Visible = False
               Me.label3.Visible = False
               Me.label4.Visible = False
               Me.label5.Visible = False
               Me.label6.Visible = False
               Me.label7.Visible = False
               Me.label8.Visible = False
               
               _status = "submitted"
               Dim statusText As New TextBox()
               statusText.Multiline = True
               statusText.BorderStyle = BorderStyle.None
               statusText.ReadOnly = True
               statusText.TabStop = False
               statusText.BackColor = Color.White
               statusText.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CByte(0))
               statusText.Name = "statusText"
               statusText.Text = "Your registration is being processed.  This may take a few moments."
               Dim grfx As Graphics = Me.CreateGraphics()
               Dim sizef As SizeF = grfx.MeasureString(statusText.Text, statusText.Font, 300)
               statusText.Width = 350
               statusText.Height = Convert.ToInt32(sizef.Height) + 50
               statusText.Location = New Point(170,(Me.Height - statusText.Height) / 2)
               Me.submit.Enabled = False
               Me.Controls.Add(statusText)
               
               Dim dataStore As New DataStore(Me)
               Dim registerInfo As New RegisterInfo(dataStore.ProductName, dataStore.GetLicenseLevel.LicenseLevel, Me.email.Text, Me.firstname.Text, Me.lastname.Text, dataStore.Devtoken, Me.address.Text, Me.city.Text, Me.state.Text, Me.zipcode.Text, Me.phone.Text, dataStore.UniqueMachineID, Me)
               
               'Create the new web service processing class and pass in the information to be transmitted
               sp = New Serverprocessing(registerInfo)
               
               'set up the event handlers for the serverProcessing Class
                    AddHandler sp.Processingcomplete, AddressOf Me.RegisterForm_ProccessingComplete '
                    AddHandler sp.Processingfailed, AddressOf Me.RegisterForm_ProccessingFailed '

               'start the web service on a seperate thread
                    Dim handleProcessingThreadStarter As New ThreadStart(AddressOf sp.HandleRegistration)
               Dim handleProcessingThread As New Thread(handleProcessingThreadStarter)
               handleProcessingThread.Start()
            End If 
         End If
      End Sub 'submit_Click
      
      
      
      #End Region
      
      
      
      Private Sub RegisterForm_Load(sender As Object, e As System.EventArgs) Handles MyBase.Load
      End Sub 'RegisterForm_Load
      
      
      
      Private Sub RegisterForm_Closing(sender As Object, e As CancelEventArgs) Handles MyBase.Closing
         
         If Not (sp Is Nothing) Then
            sp.Cancelprocessing()
         End If
      End Sub 'RegisterForm_Closing
       
      
      Private Sub firstname_TextChanged(sender As Object, e As EventArgs) Handles firstname.TextChanged
      End Sub 'firstname_TextChanged
   End Class 'RegisterForm 
End Namespace 'SSK.SSKClient.SSKForms


